Subject: Re: Set Processing

From: Dave Shield <[email-masked]>
Date: Tue, 29 Feb 2000 15:16:58 +0000

> Unfortunately, I did not get the begin of this thread (was it posted
> to the AgentX mailing list?). What is the problem with the SET request
> processing? 

To generalise a bit on Jim's reply.
He's been identifying a number of minor(-ish!) flaws in the details
of the UCD agent inplementation.  This particular thread refers to
the handling of SET failures (which did work initially, but got broken
during the run up to the latest release).

I'm currently using the defense of this being "barely-beta" code  :-)

> Until now, I only tested AgentX++ masters against AgentX++ sub-agents.
> It would be helpful to know what I have to expect from the UCD agent
> when doing my first tests ;-) 

That sounds familiar.  Until now, all the UCD AgentX testing has been
against UCD subagents as well.  

  I've tried to lay out the known deficiencies and flaws in the README
file that comes with the UCD source code for the AgentX module.
Very simply, I believe that we've implemented the all operations of the
AgentX protocol to *some* extent (though not necessarily completely).
So if you try something, you've got a sporting chance of it working!

What happens in practise, of course, may be a different kettle of fish
altogether!

I look forward to hearing your experiences.

Dave

---

From: Dave Shield <[email-masked]>
Date: Tue, 29 Feb 2000 16:37:12 +0000

> I have read the README when 4.1 has been released. I just wondered if there
> is additionally information available.

"Information" ? - whaddaya want information for?  You've got the source!

But no - there's nothing really in addition to the README, or asking me.
Nothing significant should have changed between 4.1 and 4.1.1 - that was
purely a bug-fix release.

> I have one question about the AgentX MIB implementation:

Ah!  Errr....   I do wish you hadn't said that.
When I said we'd implemented all the operations "of the protocol",
that's exactly what I meant.

<shuffles feet, and looks embarrassed>

The MIB is one of those things that didn't get done before the
release date. Sorry!

>                                                        When setting the
> admin status of a session to down(2), is the corresponding row supposed
> to be deleted from the agentxSessionTable or should it remain forever in
> its current (down) configuration? 
> 
> Because a session could not be reestablished by management, I would expect 
> the row to disappear. On the other hand, my current implementation does not
> remove the row, just because its easier to implement ;-). What do you 
> think?

I haven't read the MIB specification in detail recently (since I've been
concentrating on getting the protocol done), but since there are advantages
of doing it both ways, I'd be inclined to invoke that handy phrase
"implementation dependent".

  As far as the UCD implementation is concerned, the natural way to handle
this (i.e. what I'm planning to write when I get around to it) would mean
that rows would disappear when the session was closed - however this was done.
But obviously, I'd have to pore over the specs first to check this was legit.

Dave

---

From: Randy Presuhn <[email-masked]>
Date: Tue, 29 Feb 2000 10:02:39 -0800 (PST)

Hi -

Here is a relevant agentx forwarded post from a non-subscriber address.

 ------------------------------------------------------------------------
 Randy Presuhn           [email-masked]       http://www.bmc.com/
 Voice: +1 408 546-1006  BMC Software, Inc.  1-3141  2141 N. First Street
 Fax:   +1 408 965-0359  San Jose, California 95131  USA
 ------------------------------------------------------------------------
 Any relationship between my opinions and BMC's should be coincidental.
 ------------------------------------------------------------------------

> Received: from tangelo.bmc.com (root@tangelo [172.17.7.166])
> 	by dorothy.bmc.com (8.8.6 (PHNE_12836)/8.8.6) with ESMTP id DAA02736
> 	for <[email-masked]>; Tue, 29 Feb 2000 03:17:01 -0800 (PST)
> Received: from fw-us-hou1.bmc.com (fw-us-hou1.bmc.com [172.17.0.250])
> 	by tangelo.bmc.com (8.8.6 (PHNE_17135)/8.8.6) with SMTP id FAA27536
> 	for <[email-masked]>; Tue, 29 Feb 2000 05:17:35 -0600 (CST)
> Received: (from uucp@localhost)
> 	by gwa2.fe.bosch.de (8.9.1/8.9.1) id MAA10303
> 	for <[email-masked]>; Tue, 29 Feb 2000 12:17:55 +0100 (MET)
> Received: from fez7358.fe.bosch.de( 10.8.1.102) by gwa2.fe.bosch.de via smap (V2.1)
> 	id xma010057; Tue, 29 Feb 00 12:17:23 +0100
> Received: from leto.bk.bosch.de ([150.249.0.35]) by zeus.bk.bosch.de
>           (Netscape Messaging Server 3.0)  with ESMTP id AAA17044;
>           Tue, 29 Feb 2000 12:17:02 +0100
> Received: from marconicomms.com (localhost [127.0.0.1])
> 	by leto.bk.bosch.de (8.9.1b+Sun/8.9.1) with ESMTP id MAA19791;
> 	Tue, 29 Feb 2000 12:18:23 +0100 (MET)
> Sender: [email-masked]
> Message-ID: <[email-masked]>
> Date: Tue, 29 Feb 2000 12:18:22 +0100
> From: Frank Fock <[email-masked]>
> Organization: Marconi Communications Software Systems GmbH & Co. KG
> X-Mailer: Mozilla 4.7 [en] (X11; I; SunOS 5.7 sun4u)
> X-Accept-Language: en
> MIME-Version: 1.0
> To: Dave Shield <[email-masked]>
> CC: [email-masked], [email-masked]
> Subject: Re: Set Processing
> References: <[email-masked]>
> Content-Type: text/plain; charset=us-ascii
> Content-Transfer-Encoding: 7bit
> 
> Hi,
> 
> I am currently finishing my work on the AgentX implementation for 
> AGENT++. There are a lot of things to be tested! So, an alpha
> release won't be available before April. Nevertheless, I would like
> to use the UCD AgentX implementation for my first inter operability
> testing. 
> 
> I agree with Bob, that the UCD AgentX implementation is a very valuable
> work, which will help the AgentX community deploying this protocol. 
> 
> TIA,
> Frank Fock
> 
> 
> Dave Shield wrote:
> > 
> > > Well, speaking as chair of the AgentX WG, the open experimentation
> > > with the UCD AgentX code and the outstanding implementation feedback
> > > that you provide is the best thing happening to AgentX right now.
> > 
> > <curtsies>
> > Why thank you, kind sir.
> > 
> > (shame it doesn't work properly!)
> > 
> > > True, a number of commercial implementations are available and, as
> > > far as I know, the product support behind them is excellent...but
> > > AgentX is still at the take-off stage and the kind of exposure your
> > > implementation is getting here is critically important.  Keep up
> > > the great work!...and thanks.
> > 
> > I eagerly look forward to receiving interoperability reports
> > from these other implementations.   (This is known as a hint!)
> > 
> > Dave
>

---

From: Randy Presuhn <[email-masked]>
Date: Tue, 29 Feb 2000 10:04:29 -0800 (PST)

Hi -

Yet another non-subscriber post...

> 	by dorothy.bmc.com (8.8.6 (PHNE_12836)/8.8.6) with ESMTP id GAA03093
> 	for <[email-masked]>; Tue, 29 Feb 2000 06:39:06 -0800 (PST)
> 	by tangelo.bmc.com (8.8.6 (PHNE_17135)/8.8.6) with SMTP id IAA09479
> 	for <[email-masked]>; Tue, 29 Feb 2000 08:39:41 -0600 (CST)
> Date: Tue, 29 Feb 2000 08:38:43 -0600 (CST)
> Message-Id: <[email-masked]>
> From: [email-masked] (Jim Muchow)
> To: [email-masked]
> CC: [email-masked], [email-masked],
>         [email-masked]
> In-reply-to: <[email-masked]> (message from Frank Fock on
> 	Tue, 29 Feb 2000 12:18:22 +0100)
> Reply-to: [email-masked]
> References: <[email-masked]> <[email-masked]>
> 
> 
>    Unfortunately, I did not get the begin of this thread (was it
>    posted to the AgentX mailing list?). What is the problem with the
>    SET request processing? 
> 
> It's my fault. My situation may not be valid for all. I linked up to
> AgentX code using in a manner similar to that found in example.c or
> the AgentX tutorial.
> 
> I discovered that a set request with a varbind in error (in my tests,
> specifying an illegal or out-of-range value) doesn't return an error. I
> also discovered that SNMPv1 gets with errors return an SNMPv1 response
> with a SNMPv2 varbind error (noSuchInstance). Sets and gets that do
> not have errors are fine. 
> 
> I know where (and how) these are caused in the code. I just don't know
> how to fix them - well, I know how to hack them, I just don't know how
> to fix them correctly.
> 
> I also discovered that the code always operates in little-endian mode,
> but through some "magic" that I was unable to discern, it doesn't
> matter. 
> 
> -- 
> Jim Muchow                                             (612)912-3196 
> Now Suffering as Mr. SNMP                         fax: (612)912-4954
> Digi International                                     [email-masked]
> I used to be disgusted and now I try to be amused. [Elvis Costello]
>

---

From: Randy Presuhn <[email-masked]>
Date: Tue, 29 Feb 2000 10:10:36 -0800 (PST)

Hi -

Still another post from a non-subscriber address.
(Yes, I've added these addresses to the "posters" list,
but it looks like folks have been busy sending messages.  :-)

> 	by dorothy.bmc.com (8.8.6 (PHNE_12836)/8.8.6) with ESMTP id IAA03289
> 	for <[email-masked]>; Tue, 29 Feb 2000 08:13:01 -0800 (PST)
> 	by tangelo.bmc.com (8.8.6 (PHNE_17135)/8.8.6) with SMTP id KAA16537
> 	for <[email-masked]>; Tue, 29 Feb 2000 10:13:35 -0600 (CST)
> 	by gwa2.fe.bosch.de (8.9.1/8.9.1) id RAA24183
> 	for <[email-masked]>; Tue, 29 Feb 2000 17:13:56 +0100 (MET)
> 	id xma023809; Tue, 29 Feb 00 17:13:39 +0100
>           (Netscape Messaging Server 3.0)  with ESMTP id AAA18589;
>           Tue, 29 Feb 2000 17:13:19 +0100
> 	by leto.bk.bosch.de (8.9.1b+Sun/8.9.1) with ESMTP id RAA19966;
> 	Tue, 29 Feb 2000 17:14:39 +0100 (MET)
> Message-ID: <[email-masked]>
> Date: Tue, 29 Feb 2000 17:14:38 +0100
> CC: Jim Muchow <[email-masked]>, [email-masked],
>         [email-masked]
> References: <[email-masked]>
> No problem ;-), essential is that it shows how it works and that AgentX 
> works.
> 
> > 
> is additionally information available. I will test against the UCD
> implementation within the next two or three weeks. First, I have to
> make my code as clean as possible. 
> 
> I am curious about what will happen! I see a good chance, that it will
> work right from the start.
>  
> Sure, I will send you my experiences made during inter operability testing.
> 
> I have one question about the AgentX MIB implementation: When setting the
> Frank
> Frank Fock                     Marconi Communications Software Systems
> <[email-masked]>  Blumenstrasse 22-24, 
> Phone: +49 7191 13-4851        71522 Backnang,            
> Fax:   +49 7191 13-2502        Germany
>